#ifndef CHIP_CLK_H
#define CHIP_CLK_H

#include "chip_cfg_defs.h"
#include "chip_clk_defs.h"

/* FOUT=((m + k/65536) × FIN) / (p × 2s), where 1 ≤ p ≤ 63, 64 ≤ m ≤ 1023, 0 ≤ s ≤ 6, -32768 ≤ k ≤ 32767 */
#define CHIP_CLK_PLL_VCO_FREQ(fin,m,k,p) (((fin)*((m) + (k)/65536))/(p))
#define CHIP_CLK_PLL_FREQ(fin,m,k,p,s)   (CHIP_CLK_PLL_VCO_FREQ(fin,m,k,p) / (1 << (s)))

#define CHIP_CLK_24M_REF_FREQ           CHIP_MHZ(24)
#define CHIP_CLK_24M_REF_EN             1


#define CHIP_CLK_ARM_PLL_FREQ           CHIP_MHZ(1000) /** @todo: change to cfg */
#define CHIP_CLK_GPU_PLL_FREQ           CHIP_MHZ(1000) /** @todo: change to cfg */
#define CHIP_CLK_VPU_PLL_FREQ           CHIP_MHZ(800) /** @todo: change to cfg */
#define CHIP_CLK_DRAM_PLL_FREQ          CHIP_MHZ(1067) /** @todo: change to cfg */


#define CHIP_CLK_SYS_PLL1_FREQ          CHIP_MHZ(800) /** @todo: change to cfg */
#define CHIP_CLK_SYS_PLL1_DIV2_FREQ     (CHIP_CLK_SYS_PLL1_FREQ/2)
#define CHIP_CLK_SYS_PLL1_DIV3_FREQ     (CHIP_CLK_SYS_PLL1_FREQ/3)
#define CHIP_CLK_SYS_PLL1_DIV4_FREQ     (CHIP_CLK_SYS_PLL1_FREQ/4)
#define CHIP_CLK_SYS_PLL1_DIV5_FREQ     (CHIP_CLK_SYS_PLL1_FREQ/5)
#define CHIP_CLK_SYS_PLL1_DIV6_FREQ     (CHIP_CLK_SYS_PLL1_FREQ/6)
#define CHIP_CLK_SYS_PLL1_DIV8_FREQ     (CHIP_CLK_SYS_PLL1_FREQ/8)
#define CHIP_CLK_SYS_PLL1_DIV10_FREQ    (CHIP_CLK_SYS_PLL1_FREQ/10)
#define CHIP_CLK_SYS_PLL1_DIV20_FREQ    (CHIP_CLK_SYS_PLL1_FREQ/20)

#define CHIP_CLK_SYS_PLL1_EN            1 /** @todo: change to cfg */
#define CHIP_CLK_SYS_PLL1_DIV2_EN       CHIP_CLK_SYS_PLL1_EN
#define CHIP_CLK_SYS_PLL1_DIV3_EN       CHIP_CLK_SYS_PLL1_EN
#define CHIP_CLK_SYS_PLL1_DIV4_EN       CHIP_CLK_SYS_PLL1_EN
#define CHIP_CLK_SYS_PLL1_DIV5_EN       CHIP_CLK_SYS_PLL1_EN
#define CHIP_CLK_SYS_PLL1_DIV6_EN       CHIP_CLK_SYS_PLL1_EN
#define CHIP_CLK_SYS_PLL1_DIV8_EN       CHIP_CLK_SYS_PLL1_EN
#define CHIP_CLK_SYS_PLL1_DIV10_EN      CHIP_CLK_SYS_PLL1_EN
#define CHIP_CLK_SYS_PLL1_DIV20_EN      CHIP_CLK_SYS_PLL1_EN


#define CHIP_CLK_SYS_PLL2_FREQ          CHIP_MHZ(1000) /** @todo: change to cfg */
#define CHIP_CLK_SYS_PLL2_DIV2_FREQ     (CHIP_CLK_SYS_PLL2_FREQ/2)
#define CHIP_CLK_SYS_PLL2_DIV3_FREQ     (CHIP_CLK_SYS_PLL2_FREQ/3)
#define CHIP_CLK_SYS_PLL2_DIV4_FREQ     (CHIP_CLK_SYS_PLL2_FREQ/4)
#define CHIP_CLK_SYS_PLL2_DIV5_FREQ     (CHIP_CLK_SYS_PLL2_FREQ/5)
#define CHIP_CLK_SYS_PLL2_DIV6_FREQ     (CHIP_CLK_SYS_PLL2_FREQ/6)
#define CHIP_CLK_SYS_PLL2_DIV8_FREQ     (CHIP_CLK_SYS_PLL2_FREQ/8)
#define CHIP_CLK_SYS_PLL2_DIV10_FREQ    (CHIP_CLK_SYS_PLL2_FREQ/10)
#define CHIP_CLK_SYS_PLL2_DIV20_FREQ    (CHIP_CLK_SYS_PLL2_FREQ/20)

#define CHIP_CLK_SYS_PLL2_EN            1 /** @todo: change to cfg */
#define CHIP_CLK_SYS_PLL2_DIV2_EN       CHIP_CLK_SYS_PLL2_EN
#define CHIP_CLK_SYS_PLL2_DIV3_EN       CHIP_CLK_SYS_PLL2_EN
#define CHIP_CLK_SYS_PLL2_DIV4_EN       CHIP_CLK_SYS_PLL2_EN
#define CHIP_CLK_SYS_PLL2_DIV5_EN       CHIP_CLK_SYS_PLL2_EN
#define CHIP_CLK_SYS_PLL2_DIV6_EN       CHIP_CLK_SYS_PLL2_EN
#define CHIP_CLK_SYS_PLL2_DIV8_EN       CHIP_CLK_SYS_PLL2_EN
#define CHIP_CLK_SYS_PLL2_DIV10_EN      CHIP_CLK_SYS_PLL2_EN
#define CHIP_CLK_SYS_PLL2_DIV20_EN      CHIP_CLK_SYS_PLL2_EN


#define CHIP_CLK_SYS_PLL3_FREQ          CHIP_MHZ(1000) /** @todo: change to cfg */
#define CHIP_CLK_SYS_PLL3_EN            0 /** @todo: change to cfg */
#define CHIP_CLK_AUDIO_PLL1_FREQ        CHIP_MHZ(650) /** @todo: change to cfg */
#define CHIP_CLK_AUDIO_PLL1_EN          0 /** @todo: change to cfg */
#define CHIP_CLK_AUDIO_PLL2_FREQ        CHIP_MHZ(650) /** @todo: change to cfg */
#define CHIP_CLK_AUDIO_PLL2_EN          0 /** @todo: change to cfg */
#define CHIP_CLK_VIDEO_PLL_FREQ         CHIP_MHZ(1190) /** @todo: change to cfg */
#define CHIP_CLK_VIDEO_PLL_EN           0 /** @todo: change to cfg */




#define CHIP_CLK_AHB_FREQ           CHIP_CLK_SYS_PLL1_DIV6_FREQ /** @todo: change to cfg */
#define CHIP_CLK_IPG_FREQ           (CHIP_CLK_AHB_FREQ/2) /** @todo: change to cfg */







#define CHIP_CLK_ROOT_ENET_AXI_SRC_ID               CHIP_CLK_ID_VAL(CHIP_CLK_ROOT_ENET_AXI_SRC)
#if CHIP_CLK_ROOT_ENET_AXI_SRC_ID == CHIP_CLK_24M_REF_ID
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ         CHIP_CLK_24M_REF_FREQ
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_EN           CHIP_CLK_24M_REF_EN
#elif CHIP_CLK_ROOT_ENET_AXI_SRC_ID == CHIP_CLK_SYS_PLL1_ID
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ         CHIP_CLK_SYS_PLL1_FREQ
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_EN           CHIP_CLK_SYS_PLL1_EN
#elif CHIP_CLK_ROOT_ENET_AXI_SRC_ID == CHIP_CLK_SYS_PLL1_DIV3_ID
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ         CHIP_CLK_SYS_PLL1_DIV3_FREQ
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_EN           CHIP_CLK_SYS_PLL1_DIV3_EN
#elif CHIP_CLK_ROOT_ENET_AXI_SRC_ID == CHIP_CLK_SYS_PLL2_DIV4_ID
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ         CHIP_CLK_SYS_PLL2_DIV4_FREQ
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_EN           CHIP_CLK_SYS_PLL2_DIV4_EN
#elif CHIP_CLK_ROOT_ENET_AXI_SRC_ID == CHIP_CLK_SYS_PLL2_DIV5_ID
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ         CHIP_CLK_SYS_PLL2_DIV5_FREQ
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_EN           CHIP_CLK_SYS_PLL2_DIV5_EN
#elif CHIP_CLK_ROOT_ENET_AXI_SRC_ID == CHIP_CLK_SYS_PLL3_ID
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ         CHIP_CLK_SYS_PLL3_FREQ
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_EN           CHIP_CLK_SYS_PLL3_EN
#elif CHIP_CLK_ROOT_ENET_AXI_SRC_ID == CHIP_CLK_AUDIO_PLL1_ID
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ         CHIP_CLK_AUDIO_PLL1_FREQ
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_EN           CHIP_CLK_AUDIO_PLL1_EN
#elif CHIP_CLK_ROOT_ENET_AXI_SRC_ID == CHIP_CLK_VIDEO_PLL_ID
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ         CHIP_CLK_VIDEO_PLL_FREQ
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_EN           CHIP_CLK_VIDEO_PLL_EN
#else
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ         0
    #define CHIP_CLK_ROOT_ENET_AXI_SRC_EN           0
#endif
#define CHIP_CLK_ROOT_ENET_AXI_FREQ                 ((CHIP_CLK_ROOT_ENET_AXI_SRC_FREQ/CHIP_CLK_ROOT_ENET_AXI_PREDIV)/CHIP_CLK_ROOT_ENET_AXI_POSTDIV)


#define CHIP_CLK_ROOT_ENET_REF_SRC_ID               CHIP_CLK_ID_VAL(CHIP_CLK_ROOT_ENET_REF_SRC)
#if CHIP_CLK_ROOT_ENET_REF_SRC_ID == CHIP_CLK_24M_REF_ID
    #define CHIP_CLK_ROOT_ENET_REF_SRC_FREQ         CHIP_CLK_24M_REF_FREQ
    #define CHIP_CLK_ROOT_ENET_REF_SRC_EN           CHIP_CLK_24M_REF_EN
#elif CHIP_CLK_ROOT_ENET_REF_SRC_ID == CHIP_CLK_SYS_PLL1_DIV5_ID
    #define CHIP_CLK_ROOT_ENET_REF_SRC_FREQ         CHIP_CLK_SYS_PLL1_DIV5_FREQ
    #define CHIP_CLK_ROOT_ENET_REF_SRC_EN           CHIP_CLK_SYS_PLL1_EN
#elif CHIP_CLK_ROOT_ENET_REF_SRC_ID == CHIP_CLK_SYS_PLL2_DIV8_ID
    #define CHIP_CLK_ROOT_ENET_REF_SRC_FREQ         CHIP_CLK_SYS_PLL2_DIV8_FREQ
    #define CHIP_CLK_ROOT_ENET_REF_SRC_EN           CHIP_CLK_SYS_PLL2_DIV8_EN
#elif CHIP_CLK_ROOT_ENET_REF_SRC_ID == CHIP_CLK_SYS_PLL2_DIV10_ID
    #define CHIP_CLK_ROOT_ENET_REF_SRC_FREQ         CHIP_CLK_SYS_PLL2_DIV10_FREQ
    #define CHIP_CLK_ROOT_ENET_REF_SRC_EN           CHIP_CLK_SYS_PLL2_DIV10_EN
#elif CHIP_CLK_ROOT_ENET_REF_SRC_ID == CHIP_CLK_SYS_PLL2_DIV20_ID
    #define CHIP_CLK_ROOT_ENET_REF_SRC_FREQ         CHIP_CLK_SYS_PLL2_DIV20_FREQ
    #define CHIP_CLK_ROOT_ENET_REF_SRC_EN           CHIP_CLK_SYS_PLL2_DIV20_EN
#elif CHIP_CLK_ROOT_ENET_REF_SRC_ID == CHIP_CLK_AUDIO_PLL1_ID
    #define CHIP_CLK_ROOT_ENET_REF_SRC_FREQ         CHIP_CLK_AUDIO_PLL1_FREQ
    #define CHIP_CLK_ROOT_ENET_REF_SRC_EN           CHIP_CLK_AUDIO_PLL1_EN
#elif CHIP_CLK_ROOT_ENET_REF_SRC_ID == CHIP_CLK_VIDEO_PLL_ID
    #define CHIP_CLK_ROOT_ENET_REF_SRC_FREQ         CHIP_CLK_VIDEO_PLL_FREQ
    #define CHIP_CLK_ROOT_ENET_REF_SRC_EN           CHIP_CLK_VIDEO_PLL_EN
#elif CHIP_CLK_ROOT_ENET_REF_SRC_ID == CHIP_CLK_EXT_CLK4_ID
    #define CHIP_CLK_ROOT_ENET_REF_SRC_FREQ         CHIP_CLK_EXT_CLK4_FREQ
    #define CHIP_CLK_ROOT_ENET_REF_SRC_EN           CHIP_CLK_EXT_CLK4_EN
#else
    #define CHIP_CLK_ROOT_ENET_REF_SRC_FREQ         0
    #define CHIP_CLK_ROOT_ENET_REF_SRC_EN           0
#endif
#define CHIP_CLK_ROOT_ENET_REF_FREQ                 ((CHIP_CLK_ROOT_ENET_REF_SRC_FREQ/CHIP_CLK_ROOT_ENET_REF_PREDIV)/CHIP_CLK_ROOT_ENET_REF_POSTDIV)


#define CHIP_CLK_ROOT_ENET_TIMER_SRC_ID             CHIP_CLK_ID_VAL(CHIP_CLK_ROOT_ENET_TIMER_SRC)
#if CHIP_CLK_ROOT_ENET_TIMER_SRC_ID == CHIP_CLK_24M_REF_ID
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ       CHIP_CLK_24M_REF_FREQ
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_EN         CHIP_CLK_24M_REF_EN
#elif CHIP_CLK_ROOT_ENET_TIMER_SRC_ID == CHIP_CLK_SYS_PLL2_DIV10_ID
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ       CHIP_CLK_SYS_PLL2_DIV10_FREQ
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_EN         CHIP_CLK_SYS_PLL2_DIV10_EN
#elif CHIP_CLK_ROOT_ENET_TIMER_SRC_ID == CHIP_CLK_AUDIO_PLL1_ID
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ       CHIP_CLK_AUDIO_PLL1_FREQ
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_EN         CHIP_CLK_AUDIO_PLL1_EN
#elif CHIP_CLK_ROOT_ENET_TIMER_SRC_ID == CHIP_CLK_VIDEO_PLL_ID
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ       CHIP_CLK_VIDEO_PLL_FREQ
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_EN         CHIP_CLK_VIDEO_PLL_EN
#elif CHIP_CLK_ROOT_ENET_TIMER_SRC_ID == CHIP_CLK_EXT_CLK1_ID
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ       CHIP_CLK_EXT_CLK1_FREQ
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_EN         CHIP_CLK_EXT_CLK1_EN
#elif CHIP_CLK_ROOT_ENET_TIMER_SRC_ID == CHIP_CLK_EXT_CLK2_ID
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ       CHIP_CLK_EXT_CLK2_FREQ
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_EN         CHIP_CLK_EXT_CLK2_EN
#elif CHIP_CLK_ROOT_ENET_TIMER_SRC_ID == CHIP_CLK_EXT_CLK4_ID
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ       CHIP_CLK_EXT_CLK3_FREQ
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_EN         CHIP_CLK_EXT_CLK3_EN
#elif CHIP_CLK_ROOT_ENET_TIMER_SRC_ID == CHIP_CLK_EXT_CLK4_ID
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ       CHIP_CLK_EXT_CLK4_FREQ
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_EN         CHIP_CLK_EXT_CLK4_EN
#else
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ       0
    #define CHIP_CLK_ROOT_ENET_TIMER_SRC_EN         0
#endif
#define CHIP_CLK_ROOT_ENET_TIMER_FREQ               ((CHIP_CLK_ROOT_ENET_TIMER_SRC_FREQ/CHIP_CLK_ROOT_ENET_TIMER_PREDIV)/CHIP_CLK_ROOT_ENET_TIMER_POSTDIV)



#define CHIP_CLK_SYSCTR_BASE_FREQ   CHIP_MHZ(8)
#define CHIP_CLK_SYSCTR_SLOW_FREQ   CHIP_HZ(512)


#define CHIP_CLK_ROOT_EN

#define CHIP_CLK_ROOT_UART2_FREQ    CHIP_MHZ(24) /** @todo: change to cfg */
#define CHIP_CLK_ROOT_UART4_FREQ    CHIP_MHZ(24) /** @todo: change to cfg */

#define CHIP_CLK_ROOT_I2C1_FREQ     CHIP_MHZ(24) /** @todo: change to cfg */
#define CHIP_CLK_ROOT_I2C2_FREQ     CHIP_MHZ(24) /** @todo: change to cfg */
#define CHIP_CLK_ROOT_I2C3_FREQ     CHIP_MHZ(24) /** @todo: change to cfg */
#define CHIP_CLK_ROOT_I2C4_FREQ     CHIP_MHZ(24) /** @todo: change to cfg */
#define CHIP_CLK_ROOT_I2C5_FREQ     CHIP_MHZ(24) /** @todo: change to cfg */
#define CHIP_CLK_ROOT_I2C6_FREQ     CHIP_MHZ(24) /** @todo: change to cfg */

#endif // CHIP_CLK_H
